#!/usr/bin/env python3

import random
import string

PASSWORD = "The password for todays window is through"
SEED = 6969

functions = []
falses = []
names = set()


def genname():
    name = ""
    while name == "" or name in names:
        name = random.choice(string.ascii_lowercase) + ''.join(
            random.choices(string.ascii_lowercase + string.digits, k=2)
        )
    names.add(name)
    return name


def genfunc(indices: list[int], mode: int = 0):
    global functions
    name = genname()
    exprs = []

    if mode == 0 and len(indices) == 0:
        functions.append(f"const {name} = s => s[{len(PASSWORD)}] == undefined;")
        return name
    elif mode == 2:
        if len(falses) >= 10:
            return random.choice(falses)
        functions.append(f"const {name} = s => false;")
        falses.append(name)
        return name

    for i in range(random.randint(0, 3 if mode == 0 else 4)):
        i = random.randrange(0, len(PASSWORD))
        c = random.choice(string.ascii_letters + string.digits + ' ')
        exprs.append(f"s[{i}] == {c!r} && {genfunc(indices, mode + 1)}(s)")

    if mode == 0:
        i = indices.pop()
        exprs.append(f"s[{i}] == {PASSWORD[i]!r} && {genfunc(indices)}(s)")

    random.shuffle(exprs)
    if len(exprs) == 0:
        exprs.append("false")
    func = f"const {name} = s => {' || '.join(exprs)};"

    functions.append(func)
    return name


def main():
    random.seed(SEED)
    indices = [i for i, _ in enumerate(PASSWORD)]
    random.shuffle(indices)
    name = genfunc(indices)
    random.shuffle(functions)
    functions.append(f"const verifyPassword = {name};")
    print("\n".join(functions))


if __name__ == "__main__":
    main()
