#!/usr/bin/env python3

funcs = {}
start = goal = ""

try:
    while s := input():
        if s.startswith("const verifyPassword"):
            start = s.split(" ")[-1].strip(";")
            continue
        name, bodystr = s[len("const"):].strip().rstrip(";").split(" = s => ")
        body = []
        for expr in bodystr.split(" || "):
            if expr.endswith(" == undefined"):
                goal = name
            elif expr.startswith("s["):
                index = int(expr.split("[")[1].split("]")[0])
                char = expr.split("'")[1]
                func = expr.split(" && ")[1].split("(s)")[0]
                body.append([index, char, func])
        funcs[name] = body
except EOFError:
    pass


def dfs(name, password: dict[int, str]):
    if name == goal:
        return password
    if name not in funcs:
        return None
    for index, char, next in funcs[name]:
        pw = password.copy()
        pw[index] = char
        if (p := dfs(next, pw)) is not None:
            return p


def main():
    pw = []
    for i, val in dfs(start, {}).items():
        while i >= len(pw):
            pw.append('?')
        pw[i] = val

    print("".join(pw))


if __name__ == "__main__":
    main()
